# This code is copyrighted by Stephan Richter in July, 2001.
#
# It is Open Source. See the LICENSE.txt for more details!
#
# written by Stephan Richter
# Last updated: July 28, 2001
import Globals, os
from OFS.DTMLMethod import DTMLMethod
from ExternalObject import ExternalObject

manage_addExternalDTMLMethodForm = Globals.DTMLFile('dtml/manage_addExternalDTMLMethodForm', globals())


def manage_addExternalDTMLMethod(self, id, REQUEST=None):
    '''manage_addExternalDTMLMethod(self, id, REQUEST=None) --> Add a DTML Method to the File System;
       return HTML'''
    file = open(os.path.join(self._getPath(), id), 'w')
    file.close()

    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


class ExternalDTMLMethod(ExternalObject, DTMLMethod):
    '''ExternalFile class - Describes a DTML Method in the file system'''

    meta_type = 'External DTML Method'

    manage_options = DTMLMethod.manage_options[:2]

    def munge(self, source_string=None, mapping=None, **vars):
        '''munge(self, source_string=None, mapping=None, **vars) --> overload this method, so we can
           also write to the File System; return None'''

        result = apply(DTMLMethod.inheritedAttribute('munge'),
                       (self, source_string, mapping), vars)

        # Now we save it to the File System, but only if the object is part of the
        # object tree, otherwise we have no clue wher to save the file!
        if self.getParentNode():
            file = open(os.path.join(self.aq_parent._getPath(), self.getId()), 'w')
            file.write(self.read())
            file.close()
            
        return result
