# This code is copyrighted by Stephan Richter in July, 2001.
#
# It is Open Source. See the LICENSE.txt for more details!
#
# written by Stephan Richter
# Last updated: July 28, 2001
import Globals, os
from OFS.Image      import File
from ExternalObject import ExternalObject


manage_addExternalFileForm = Globals.DTMLFile('dtml/manage_addExternalFileForm', globals())

def manage_addExternalFile(self, id, REQUEST=None):
    '''manage_addExternalFile(self, id, REQUEST=None) --> Add a File to the File System;
       return HTML'''
    file = open(os.path.join(self._getPath(), id), 'w')
    file.close()

    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


class ExternalFile(ExternalObject, File):
    '''ExternalFile class - Describes a File in the file system'''

    meta_type = 'External File'

    # Limit the options, since this object is not really a Zope object
    manage_options = File.manage_options[:2]


    def manage_upload(self,file='',REQUEST=None):
        '''manage_upload(self,file='',REQUEST=None) --> overload this method, so we can
           also write to the File System; return None'''
        # Upload the file
        result = File.inheritedAttribute('manage_upload')(self, file, REQUEST)
    
        # Now we save it to the File System, but only if the object is part of the
        # object tree, otherwise we have no clue wher to save the file!
        if self.getParentNode():
            file = open(os.path.join(self.aq_parent._getPath(), self.getId()), 'w')
            file.write(self.data)
            file.close()
        
        return result
