# This code is copyrighted by Stephan Richter in July, 2001.
#
# It is Open Source. See the LICENSE.txt for more details!
#
# written by Stephan Richter
# Last updated: July 28, 2001
import Globals, os
from OFS.Image      import Image
from ExternalObject import ExternalObject


manage_addExternalImageForm = Globals.DTMLFile('dtml/manage_addExternalImageForm', globals())

def manage_addExternalImage(self, id, REQUEST=None):
    '''manage_addExternalImage(self, id, REQUEST=None) --> Add an Image to the File System;
       return HTML'''
    file = open(os.path.join(self._getPath(), id), 'w')
    file.close()

    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


class ExternalImage(ExternalObject, Image):
    '''ExternalImage class - Describes an Image in the file system'''

    meta_type = 'External Image'

    # Limit the options, since this object is not really a Zope object
    manage_options = Image.manage_options[:2]


    def manage_upload(self,file='',REQUEST=None):
        '''manage_upload(self,file='',REQUEST=None) --> overload this method, so we can
           also write to the File System; return None'''
        # Upload the file
        result = Image.inheritedAttribute('manage_upload')(self, file, REQUEST)

        # Now we save it to the File System, but only if the object is part of the
        # object tree, otherwise we have no clue wher to save the file!
        if self.getParentNode():
            file = open(os.path.join(self.aq_parent._getPath(), self.getId()), 'w')
            file.write(self.data)
            file.close()
        
        return result



