# This code is copyrighted by Stephan Richter in July, 2001.
#
# It is Open Source. See the LICENSE.txt for more details!
#
# written by Stephan Richter
# Last updated: July 28, 2001
from DateTime import DateTime
import os, stat


class ExternalObject:
    '''ExternalObject class - Some common definitions/methods of the
       External Objects'''

    # Make it movable. Mainly useful for renaming.
    cb_isMoveable = 1

    def _getPath(self):
        '''_getPath(self) --> Get the external path of the object; return string'''
        return os.path.join(self.aq_parent._getPath(), self.getId())
    
    def bobobase_modification_time(self):
        '''bobobase_modification_time(self) --> Get the modification time from the
           file system (taken from LocalFS); return DateTime'''
        t = os.stat(self._getPath())[stat.ST_MTIME]
        return DateTime(t)
