# This code is copyrighted by Stephan Richter in July, 2001.
#
# It is Open Source. See the LICENSE.txt for more details!
#
# written by Stephan Richter
# Last updated: July 28, 2001
import Globals, os
from Products.PythonScripts.PythonScript import PythonScript 
from ExternalObject                      import ExternalObject


manage_addExternalPythonScriptForm = Globals.DTMLFile('dtml/manage_addExternalPythonScriptForm', globals())

def manage_addExternalPythonScript(self, id, REQUEST=None):
    '''manage_addExternalPythonScript(self, id, REQUEST=None) --> add an external Python Script;
       return HTML'''
    # Open and Close a new file, so that it is created.
    file = open(os.path.join(self._getPath(), id), 'w')
    file.close()

    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


class ExternalPythonScript(ExternalObject, PythonScript):
    '''ExternalPythonScript --> Describes a Python File in the file system'''

    meta_type = 'External Python Script'

    manage_options = (PythonScript.manage_options[0], PythonScript.manage_options[2])


    def write(self, text):
        '''write(self, text) --> overload the method so that we can also save to the file system;
           return None'''
        result = PythonScript.write(self, text)

        # We can only write to the file system, when we are part of the object tree, otherwise
        # we have no clue where to save the file.
        if self.getParentNode():
            file = open(os.path.join(self.aq_parent._getPath(), self.getId()), 'w')
            file.write(self.body())
            file.close()

        return result
