# This code is copyrighted by Stephan Richter in July, 2001.
#
# It is Open Source. See the LICENSE.txt for more details!
#
# written by Stephan Richter
# Last updated: July 28, 2001
import Globals, os 
from ExternalFolder import ExternalFolder


manage_addProductViewForm = Globals.DTMLFile('dtml/manage_addProductViewForm', globals()) 


def manage_addProductView(self, id, product, title='', REQUEST=None):
    '''manage_addProductView(self, id, product, title='', REQUEST=None) --> add a Product View;
       return HTML'''
    pv = ProductView(id, product, title)
    self._setObject(id, pv)

    if REQUEST is not None:
        return self.manage_main(self, REQUEST, update_menu=1)
    

class ProductView(ExternalFolder):
    '''ProductView class - This object contains all the files of a product as Zope object.

       The 'path' variable is usually the product name, but really describes the directory
       structure after ZOPE/lib/python/Products.
    '''

    meta_type = 'Product View'

    def __init__(self, id, product='', title=''):
        '''__init__(self, id, product, title='') --> initialize object; return None'''
        self.id = str(id)
        if product:
            self.path = product
        else:
            self.path = self.id
        self.title = title


Globals.default__class_init__(ProductView)

    
def registerExternalObject(klass, constructors):
    '''registerExternalObject(klass, constructors) --> register the objects that can be contained
       by a External Folder. This way we can control the objects that go into the Folder;
       return None'''

    # The meta-type dictionary is being prepared
    dict = { 'name'   : klass.meta_type,
             'action' : constructors[0].__name__ }

    # register the constructors in the External Folder 
    for constructor in constructors:
        setattr(ExternalFolder, constructor.__name__, constructor)
        
    # Add the meta type entry to the registry
    ExternalFolder._meta_types = ExternalFolder._meta_types + (dict,)


    
